//#include "config.h"
#include <X11/Xlib.h>
#include <X11/extensions/XShm.h>
#include <X11/Xutil.h>
#include <X11/extensions/shape.h>
#include <X11/Xatom.h>
#include <X11/Xos.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <math.h>

/*
#include <sys/time.h>
#include "common.h"
#include "image.h"
#include "rend.h"
#include "rgba.h"
#include "ximage.h"
#include "color.h"
 */

Display            *disp;
Window              win;
Visual             *vis;
Colormap            cm;
int                 depth;
XSetWindowAttributes attr;
char *appToRun;

int main(int argc, char **argv)
{
  int                 w, h, x, y;
  XEvent              ev;
  const char         *display_name = getenv("DISPLAY");


  if (display_name == NULL)
    display_name = ":0";
  disp = XOpenDisplay(display_name);
  if (disp == NULL) 
  {
    fprintf(stderr, "Can't open display %s\n", display_name);
    return 1;
  }

  int screen=DefaultScreen(disp);
  int hidemode=0;
  int submode=0;
  int sizeOfMainIcons=0;
  int GapBetweenMainIcons=0;
  int sizeOfSubmenueIcons=0;
  int GapBetweenSubIcons=0;
  int store=0;
  int mode=1;
  char selectedgroup[1024];
  int raisemode;
  int xmain;
  int ymain;
  int sizemain;
  int gapmain;
  int sizesub;
  int gapsub;
  int autohidemainbutton;
  int autohideSubbutton;
  int MouseMoveOpenSubIcon;
  char usermenufile[1024];
  char result[1024]="";
  char run_mode[1024]="";
  int i=0;
  char home[1024];
  char command[1024]=" ";
  int showclock=0;
  FILE *freeNum;
  sprintf(home,"%s",getenv("HOME"));
  if ( argc == 3 ) 
  {
    sscanf(argv[1], "%s", &run_mode);
    sscanf(argv[2], "%s", &home);
    if (strcmp(run_mode,"INIT")==0 )
    {
      mode=2;
    }
    if (strcmp(run_mode,"START")==0 )
    {
      mode=0;
    }
  }
  if ( argc == 6 ) 
  {
    sscanf(argv[1], "%d", &x);
    sscanf(argv[2], "%d", &y);
    sscanf(argv[3], "%s", &selectedgroup);
    sscanf(argv[4], "%d", &raisemode);
    sscanf(argv[5], "%s", &home);
    mode=1;
  }
  if ( home == "" )
  {
    printf("fatal error: no /home/xxx found!\n");
    return 1;
  }
  char rcfile[256]="menu.rc";
  sprintf(usermenufile,"%s/.iconmenu/%s",home,rcfile);
  freeNum=fopen(usermenufile,"r");
  if ( freeNum==NULL)
  { 
    printf("error on open %s\n",usermenufile); 
    exit(1); 
  }
  int gc=0;
  char ch;
  char ch2[1024];
  char buffer[1024];
  int n=0;
  int m=0;
  char group[1024]="0";
  while ( ! feof(freeNum) )
  {
    fgets(buffer,1024,freeNum);
    
//    printf("%s\n",buffer); 
    sprintf(command,"");
    if (strcmp(buffer,"")!=0 )
    {
      sprintf(ch2,"%c",buffer[0]);
      if (strcmp(ch2,"#")!=0 ) 
      {
        sprintf(ch2,"%c%c%c%c%c%c%c%c%c%c",buffer[0],buffer[1],buffer[2],buffer[3],buffer[4],buffer[5],buffer[6],buffer[7],buffer[8],buffer[9]);
        if (strcmp(ch2,"showclock:")==0 )
        {
          for (n=0;n<1024;n++)
          {
             buffer[n]=buffer[n+10];
          } 
          for (n=1011;n<1024;n++)
          {
             buffer[n]='\0';
          }
          m=0;
          ch='a';
          sprintf(ch2,"");
          while ( buffer[m] != ' ' )
          {
            sprintf(ch2,"%s%c",ch2,buffer[m]);
            m=m+1;
          }
          showclock = atoi(ch2);
        }
        sprintf(ch2,"%c%c%c%c%c%c%c%c%c%c%c",buffer[0],buffer[1],buffer[2],buffer[3],buffer[4],buffer[5],buffer[6],buffer[7],buffer[8],buffer[9],buffer[10]);
        if (strcmp(ch2,"baseconfig:")==0 )
        {
          for (n=0;n<1024;n++)
          {
             buffer[n]=buffer[n+11];
          } 
          for (n=1012;n<1024;n++)
          {
             buffer[n]='\0';
          } 
          printf("baseconfig:%s\n",buffer); 
          m=0;
          ch='a';
          sprintf(ch2,"");
          while ( buffer[m] != ' ' )
          {
            sprintf(ch2,"%s%c",ch2,buffer[m]);
            m=m+1;
          }
          for (n=0;n<1024-m;n++)
          {
             buffer[n]=buffer[n+m+1];
          } 
          for (n=1024-m;n<1024;n++)
          {
             buffer[n]='\0';
          } 
          xmain = atoi(ch2);
          m=0;
          ch='a';
          sprintf(ch2,"");
          while ( buffer[m] != ' ' )
          {
            sprintf(ch2,"%s%c",ch2,buffer[m]);
            m=m+1;
          }
          for (n=0;n<1024-m;n++)
          {
             buffer[n]=buffer[n+m+1];
          } 
          for (n=1024-m;n<1024;n++)
          {
             buffer[n]='\0';
          } 
          ymain = atoi(ch2);
          m=0;
          ch='a';
          sprintf(ch2,"");
          while ( buffer[m] != ' ' )
          {
            sprintf(ch2,"%s%c",ch2,buffer[m]);
            m=m+1;
          }
          for (n=0;n<1024-m;n++)
          {
             buffer[n]=buffer[n+m+1];
          } 
          for (n=1024-m;n<1024;n++)
          {
             buffer[n]='\0';
          } 
          sizemain = atoi(ch2);
          m=0;
          ch='a';
          sprintf(ch2,"");
          while ( buffer[m] != ' ' )
          {
            sprintf(ch2,"%s%c",ch2,buffer[m]);
            m=m+1;
          }
          for (n=0;n<1024-m;n++)
          {
             buffer[n]=buffer[n+m+1];
          } 
          for (n=1024-m;n<1024;n++)
          {
             buffer[n]='\0';
          } 
          gapmain = atoi(ch2);
          m=0;
          ch='a';
          sprintf(ch2,"");
          while ( buffer[m] != ' ' )
          {
            sprintf(ch2,"%s%c",ch2,buffer[m]);
            m=m+1;
          }
          for (n=0;n<1024-m;n++)
          {
             buffer[n]=buffer[n+m+1];
          } 
          for (n=1024-m;n<1024;n++)
          {
             buffer[n]='\0';
          } 
          sizesub = atoi(ch2);
          m=0;
          ch='a';
          sprintf(ch2,"");
          while ( buffer[m] != ' ' )
          {
            sprintf(ch2,"%s%c",ch2,buffer[m]);
            m=m+1;
          }
          for (n=0;n<1024-m;n++)
          {
             buffer[n]=buffer[n+m+1];
          } 
          for (n=1024-m;n<1024;n++)
          {
             buffer[n]='\0';
          } 
          gapsub = atoi(ch2);
          m=0;
          ch='a';
          sprintf(ch2,"");
          while ( buffer[m] != ' ' )
          {
            sprintf(ch2,"%s%c",ch2,buffer[m]);
            m=m+1;
          }
          for (n=0;n<1024-m;n++)
          {
             buffer[n]=buffer[n+m+1];
          } 
          for (n=1024-m;n<1024;n++)
          {
             buffer[n]='\0';
          } 
          raisemode = atoi(ch2);
          m=0;
          ch='a';
          sprintf(ch2,"");
          while ( buffer[m] != ' ' )
          {
            sprintf(ch2,"%s%c",ch2,buffer[m]);
            m=m+1;
          }
          for (n=0;n<1024-m;n++)
          {
             buffer[n]=buffer[n+m+1];
          } 
          for (n=1024-m;n<1024;n++)
          {
             buffer[n]='\0';
          } 
          autohidemainbutton = atoi(ch2);
          printf("%c",buffer);
          m=0;
          ch='a';
          sprintf(ch2,"");
          while ( buffer[m] != ' ' )
          {
            sprintf(ch2,"%s%c",ch2,buffer[m]);
            m=m+1;
          }
          for (n=0;n<1024-m;n++)
          {
             buffer[n]=buffer[n+m+1];
          } 
          for (n=1024-m;n<1024;n++)
          {
             buffer[n]='\0';
          } 
          autohideSubbutton = atoi(ch2);
          printf("%c",buffer);
          MouseMoveOpenSubIcon= atoi(buffer);

        }
        sprintf(ch2,"%c%c%c%c%c",buffer[0],buffer[1],buffer[2],buffer[3],buffer[4]);
        if (strcmp(ch2,"group")==0 )
        {
          m=0;
          ch='a';
          sprintf(ch2,"");
          while ( buffer[m] != ' ' )
          {
            sprintf(ch2,"%s%c",ch2,buffer[m]);
            m=m+1;
          }
          for (n=0;n<1024-m;n++)
          {
             buffer[n]=buffer[n+m];
          } 
          for (n=1023-m;n<1024;n++)
          {
             buffer[n]='\0';
          } 
          for (n=0;n<m-5;n++)
          {
             ch2[n]=ch2[n+5];
          } 
          for (n=m-6;n<m;n++)
          {
             ch2[n]='\0';
          }
          sprintf(group,"%s",ch2);
          for (n=0;n<1024;n++)
          { 
            if (buffer[n]=='\n')
            {
              buffer[n]='\0';
            }
          }    

          if (mode==2)
          {
            sprintf(command,"./iconrun1 %d %d %d %d %d %s %s %d %d %d &\n",xmain,ymain+gc*(sizemain+gapmain),sizemain,sizemain,raisemode,group,buffer,autohidemainbutton,MouseMoveOpenSubIcon,showclock);
            printf("./iconrun1 %d %d %d %d %d %s %s %d %d %d &\n",xmain,ymain+gc*(sizemain+gapmain),sizemain,sizemain,raisemode,group,buffer,autohidemainbutton,MouseMoveOpenSubIcon,showclock);
            system(command);
          }
          if (mode==0)
          {  //usage: iconrun2 x y width height lower/raise(0/1) autohideSubbutton(0/1/2) MouseMoveOpenSubIcon(0/1/2) group image title application/home single/group(0/1) \n");
            sprintf(command,"./iconrun2 %d %d %d %d %d %d %d %s %s %s 1 &\n",xmain,ymain+gc*(sizemain+gapmain),sizemain,sizemain,raisemode,autohideSubbutton,MouseMoveOpenSubIcon,group,buffer,home);
            printf("./iconrun2 %d %d %d %d %d %d %d %s %s %s 1 &\n",xmain,ymain+gc*(sizemain+gapmain),sizemain,sizemain,raisemode,autohideSubbutton,MouseMoveOpenSubIcon,group,buffer,home);
            system(command);
            gc=gc+1;
          }
        }
        else
        {
          sprintf(ch2,"%c%c%c%c%c%c",buffer[0],buffer[1],buffer[2],buffer[3],buffer[4],buffer[5]);
          if (strcmp(ch2,"single")==0 )
          {
            m=0;
            ch='a';
            sprintf(ch2,"");
            while ( buffer[m] != ' ' )
            {
              sprintf(ch2,"%s%c",ch2,buffer[m]);
              m=m+1;
            }
            for (n=0;n<1024-m;n++)
            {
               buffer[n]=buffer[n+m];
            } 
            for (n=1023-m;n<1024;n++)
            {
               buffer[n]='\0';
            } 
            for (n=0;n<m-6;n++)
            {
               ch2[n]=ch2[n+6];
            } 
            for (n=m-7;n<m;n++)
            {
               ch2[n]='\0';
            }

            for (n=0;n<1024;n++)
            { 
              if (buffer[n]=='\n')
              {
                buffer[n]='\0';
              }
            }    
            sprintf(group,"%s",ch2);
            if (mode==0)
            {
              sprintf(command,"./iconrun2 %d %d %d %d %d %d %d %s %s 0 &\n",xmain,ymain+gc*(sizemain+gapmain),sizemain,sizemain,raisemode,autohideSubbutton,MouseMoveOpenSubIcon,group,buffer);
              printf("./iconrun2 %d %d %d %d %d %d %d %s %s 0 &\n",xmain,ymain+gc*(sizemain+gapmain),sizemain,sizemain,raisemode,autohideSubbutton,MouseMoveOpenSubIcon,group,buffer);
              system(command);
              gc=gc+1;
            }
          }
          else
          {
            for (n=0;n<1024;n++)
            { 
              if (buffer[n]=='\n')
              {
                buffer[n]='\0';
              }
            }    
            if (( mode == 1 ) and (strcmp(group,selectedgroup)==0 ))
            {
              sprintf(command,"./iconrun3 %d %d %d %d %d %d %s &\n", (x+gapsub+(sizesub+gapsub)*i),y-((sizesub-sizemain)/2),sizesub,sizesub,raisemode,MouseMoveOpenSubIcon,buffer);
              printf("./iconrun3 %d %d %d %d %d %d %s &\n", (x+gapsub+(sizesub+gapsub)*i),y-((sizesub-sizemain)/2),sizesub,sizesub,raisemode,MouseMoveOpenSubIcon,buffer);
              system(command);
              i=i+1;
            }
          }
        }   
      } 
    }
  }
  fclose(freeNum);
  return 0;

}

